module ServiceStack
  class Function
    attr_reader :input, :options

    Error = Class.new(StandardError) do
      attr_reader :message, :data

      def initialize(message, data = nil)
        @message = message
        @data = data
      end
    end

    def self.perform(input, options = {})
      new(input, options).call
    end

    def initialize(input, options = {})
      @input = input
      @options = (options.is_a?(Hash) ? options.dup : {}).freeze
    end

    def call
      raise "#call not implemented in #{self.class}"
    end
  end
end
