module ServiceStack
  class Pipeline
    PIPES_MAP = {
      uppercase: Pipes::UppercasePipe
    }.freeze

    def initialize(pipes)
      @pipes = pipes.map do |pipe|
        pipe.is_a?(Symbol) ? PIPES_MAP.fetch(pipe) : pipe
      end
    end

    def transform(value)
      @pipes.reduce(value) do |new_value, pipe|
        pipe.transform(new_value)
      end
    end
  end
end
